//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3DAC41200399.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3DAC41200399.cm

//## begin module%3DAC41200399.cp preserve=no
//## end module%3DAC41200399.cp

//## Module: PlotGroup%3DAC41200399; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotGroup.h

#ifndef PLOTGROUP_H
#define PLOTGROUP_H 1

//## begin module%3DAC41200399.additionalIncludes preserve=no
//## end module%3DAC41200399.additionalIncludes

//## begin module%3DAC41200399.includes preserve=yes
//## end module%3DAC41200399.includes

// xsTypes
#include <main/xsTypes.h>
// PlotVector
#include <XSPlot/Plot/PlotVector.h>
// PlotTypes
#include <XSPlot/Plot/PlotTypes.h>
// PlotSettings
#include <XSPlot/Plot/PlotSettings.h>
//## begin module%3DAC41200399.declarations preserve=no
//## end module%3DAC41200399.declarations

//## begin module%3DAC41200399.additionalDeclarations preserve=yes
//## end module%3DAC41200399.additionalDeclarations


//## Class: PlotGroup%3D947E240111
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%4AC6426F00FE;PlotSettings { -> }

struct PlotGroup 
{
    //## Constructors (specified)
      //## Operation: PlotGroup%3D9878BD0219
      //	Except for xAxis, all PlotVectors will remain size 0
      //	unless explicitly set.  yData and model vectors can be
      //	set here upon construction, all others must be done from
      //	outside.
      PlotGroup (int arraySize, size_t nMods = 0, bool useYdata = true);

      //## Operation: PlotGroup%4B4E1D29021E
      //	Special constructor to be used for 2D contour plotting.
      //	This places the xVals and yVals values into the xAxis
      //	and yData PlotVectors, and sizes the model[0] array to
      //	(x size)*(y size).  No error vectors are created here.
      PlotGroup (const std::vector<Real>& xVals, const std::vector<Real>& yVals);


    //## Other Operations (specified)
      //## Operation: operator<%3E1C7F5B0214
      friend bool operator < (const PlotGroup& left, const PlotGroup& right);

      //## Operation: copyAttributes%4B6348E8014F
      //	A utility function intended for copying only the Plot
      //	Group attributes which are NOT dependent upon the
      //	distribution of filled PlotVectors (or their size -- n
      //	is not copied).  It also does not copy the objectIndex,
      //	as that must be unique for every PlotGroup.
      void copyAttributes (const PlotGroup& right);

    // Data Members for Class Attributes

      //## Attribute: objectIndex%4B142D2A000C
      //	This is neither the xspec plot group number that the
      //	user may set through setplot, nor the group index number
      //	as used by PLT.  This is the index of the PlotGroup
      //	object where ALL PlotGroup objects in a (possibly
      //	multi-paned)  display are numbered consecutively 1..N.
      //	PlotDirector is the only class with the wherewithal to
      //	set this, as it has knowledge of all the PlotPanes that
      //	will make up the display.
      //## begin PlotGroup::objectIndex%4B142D2A000C.attr preserve=no  public: size_t {U} 
      size_t objectIndex;
      //## end PlotGroup::objectIndex%4B142D2A000C.attr

      //## Attribute: channelPlotSpacing%3D9488580365
      //	ichtot from xspec 11.
      //
      //	This is the spacing in the channel axis (x) between
      //	this and the next plot group.
      //## begin PlotGroup::channelPlotSpacing%3D9488580365.attr preserve=no  public: int {U} 
      int channelPlotSpacing;
      //## end PlotGroup::channelPlotSpacing%3D9488580365.attr

      //## Attribute: n%3D9490170281
      //	For standard plots, n should be the size of all
      //	non-empty PlotVectors.  For PlotGroups used in 2D
      //	contour plots, n = (xAxis size)*(yData size) = aux
      //	Data[0] size.
      //## begin PlotGroup::n%3D9490170281.attr preserve=no  public: size_t {U} 
      size_t n;
      //## end PlotGroup::n%3D9490170281.attr

      //## Attribute: is2Dcontour%4B4E1B4301A0
      //	If true, the X and Y axis values will be stored in xAxis
      //	and yData vectors, and the grid values will be in the aux
      //	Data[0] vector.
      //## begin PlotGroup::is2Dcontour%4B4E1B4301A0.attr preserve=no  public: const bool {U} 
      const bool is2Dcontour;
      //## end PlotGroup::is2Dcontour%4B4E1B4301A0.attr

      //## Attribute: critSignificance%3D949910010F
      //## begin PlotGroup::critSignificance%3D949910010F.attr preserve=no  public: Real {U} 
      Real critSignificance;
      //## end PlotGroup::critSignificance%3D949910010F.attr

      //## Attribute: critNumChans%3D94992E015C
      //## begin PlotGroup::critNumChans%3D94992E015C.attr preserve=no  public: int {U} 
      int critNumChans;
      //## end PlotGroup::critNumChans%3D94992E015C.attr

      //## Attribute: errorType%3D949BE10048
      //## begin PlotGroup::errorType%3D949BE10048.attr preserve=no  public: PlotSettings::PlotErrMode {U} 
      PlotSettings::PlotErrMode errorType;
      //## end PlotGroup::errorType%3D949BE10048.attr

      //## Attribute: single%3D986C9A0386
      //## begin PlotGroup::single%3D986C9A0386.attr preserve=no  public: bool {U} 
      bool single;
      //## end PlotGroup::single%3D986C9A0386.attr

      //## Attribute: lastInputChannel%3D98A84501CA
      //## begin PlotGroup::lastInputChannel%3D98A84501CA.attr preserve=no  public: int {U} 
      int lastInputChannel;
      //## end PlotGroup::lastInputChannel%3D98A84501CA.attr

      //## Attribute: bin%3D9B5725004B
      //## begin PlotGroup::bin%3D9B5725004B.attr preserve=no  public: int {U} 
      int bin;
      //## end PlotGroup::bin%3D9B5725004B.attr

      //## Attribute: bundledPlotVectors%452D0D8B039D
      //## begin PlotGroup::bundledPlotVectors%452D0D8B039D.attr preserve=no  public: std::vector<PlotVector*> {U} 
      std::vector<PlotVector*> bundledPlotVectors;
      //## end PlotGroup::bundledPlotVectors%452D0D8B039D.attr

      //## Attribute: plotVectorBoundaries%452D0DF50064
      //## begin PlotGroup::plotVectorBoundaries%452D0DF50064.attr preserve=no  public: IntegerArray {U} 
      IntegerArray plotVectorBoundaries;
      //## end PlotGroup::plotVectorBoundaries%452D0DF50064.attr

    // Data Members for Associations

      //## Association: XSPlot::Plot::<unnamed>%3E03335A01D3
      //## Role: PlotGroup::saveData%3E03335E0054
      //## begin PlotGroup::saveData%3E03335E0054.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray saveData;
      //## end PlotGroup::saveData%3E03335E0054.role

      //## Association: XSPlot::Plot::<unnamed>%456362BB032F
      //## Role: PlotGroup::background%456362BE018B
      //## begin PlotGroup::background%456362BE018B.role preserve=no  public: PlotVector { -> 1VHgN}
      PlotVector background;
      //## end PlotGroup::background%456362BE018B.role

      //## Association: Individual Sources%3DD3E2BB0106
      //## Role: PlotGroup::sources%3DD3E2BC0363
      //## begin PlotGroup::sources%3DD3E2BC0363.role preserve=no  public: PlotVectorList { -> 1..nVHgN}
      std::vector<PlotVectorList> sources;
      //## end PlotGroup::sources%3DD3E2BC0363.role

      //## Association: <unnamed>%3DD3DBDF0271
      //## Role: PlotGroup::xAxis%3DD3DBE2026B
      //## begin PlotGroup::xAxis%3DD3DBE2026B.role preserve=no  public: PlotVector { -> 1VHgN}
      PlotVector xAxis;
      //## end PlotGroup::xAxis%3DD3DBE2026B.role

      //## Association: <unnamed>%3DD3DDCB0155
      //## Role: PlotGroup::yData%3DD3DDCC01AB
      //## begin PlotGroup::yData%3DD3DDCC01AB.role preserve=no  public: PlotVector { -> 1VHgN}
      PlotVector yData;
      //## end PlotGroup::yData%3DD3DDCC01AB.role

      //## Association: <unnamed>%3DD3DE27023A
      //## Role: PlotGroup::model%3DD3DE2802E3
      //## begin PlotGroup::model%3DD3DE2802E3.role preserve=no  public: PlotVector { -> 1..nVHgN}
      std::vector<PlotVector> model;
      //## end PlotGroup::model%3DD3DE2802E3.role

      //## Association: <unnamed>%3DD3DEFB01E2
      //## Role: PlotGroup::auxData%3DD3DEFC023E
      //## begin PlotGroup::auxData%3DD3DEFC023E.role preserve=no  public: PlotVector { -> 1..nVHgN}
      std::vector<PlotVector> auxData;
      //## end PlotGroup::auxData%3DD3DEFC023E.role

  public:
  protected:
  private:
  private: //## implementation
};

// Class PlotGroup 

//## begin module%3DAC41200399.epilog preserve=yes
//## end module%3DAC41200399.epilog


#endif
